Attribute VB_Name = "Module10"

' Fonction API WINDOWS permettant de localiser le rpertoire WINDOWS
Declare Function GetWindowsDirectory Lib "kernel32" Alias "GetWindowsDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long

' Ecriture dans un fichier ASCII(.INI)
Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long

' Extraction d'informations d'une section d'un fichier ASCII(.INI)
Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long

' Extraction de toutes les sections d'un fichier ASCII(.INI)
Declare Function GetProfileString Lib "kernel32" Alias "GetProfileStringA" (ByVal lpAppName As String, ByVal lpKeyName As String, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long) As Long

' Fonctions API pour accs  la base de registre
Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) As Long
Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, phkResult As Long) As Long
Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long

' Constantes
Public Const HKEY_CLASSES_ROOT = &H80000000
Public Const HKEY_CURRENT_USER = &H80000001
Public Const HKEY_LOCAL_MACHINE = &H80000002
Public Const HKEY_USERS = &H80000003
Public Const HKEY_PERFORMANCE_DATA = &H80000004
Public Const HKEY_CURRENT_CONFIG = &H80000005
Public Const HKEY_DYN_DATA = &H80000006
Public Const KEY_ALL_ACCESS As Long = &HF0063
Public Const ERROR_SUCCESS As Long = 0
Public Const REG_SZ As Long = 1
Option Explicit

' Clavier
Public Type KeyboardBytes
    kbByte(0 To 255) As Byte
End Type

Public kbArray As KeyboardBytes
Public Declare Function GetKeyState Lib "user32" (ByVal nVirtKey As Long) As Long
Public Declare Function GetKeyboardState Lib "user32" (kbArray As KeyboardBytes) As Long
Public Declare Function SetKeyboardState Lib "user32" (kbArray As KeyboardBytes) As Long

'
' Set / Reset une touche clavier
'
Sub ToucheClavier(Numro As Integer, Etat As Boolean)

    ' Acquisition de l'tat du clavier
    GetKeyboardState kbArray
    
    ' Set / Reset le bit correspondant  la touche
    If Etat = True Then
        ' Set
        kbArray.kbByte(Numro) = 1
    Else
        ' Reset
        kbArray.kbByte(Numro) = 0
    End If
    
    ' Modifie l'tat du clavier
    SetKeyboardState kbArray

End Sub

'
' Suppression d'une section complte du fichier ASCII (.INI)
'
Sub EffaceSectionFichierASCII(Fichier As String, Section As String)

Dim Succs
    
    Succs = WritePrivateProfileString(Section, 0&, 0&, Fichier)

End Sub

'
' Recherche du chemin d'accs au rpertoire WINDOWS
'
Function AccsWindows() As String

Dim i As Integer
Dim Chemin As String
Dim Gwdvar As String
Dim Gwdvar_Longueur As Integer

    For i = 67 To 70
        
        ' Recherche sur chaque unit
        ChDrive Chr(i)
    
        ' rserve de l'espace mmoire pour les rsultats
        Gwdvar = Space$(255)
        Gwdvar_Longueur = GetWindowsDirectory(Gwdvar, 255)
        Chemin = Left(Gwdvar, Gwdvar_Longueur)
        
        If Chemin <> "" Then
            AccsWindows = Chemin + "\"
            Exit Function
        End If

    Next i

End Function

'
' Ecriture d'informations dans un fichier ASCII(.INI)
'
Sub EcritureFichierASCII(Fichier As String, Section As String, Cl As String, Valeur As String)

Dim Succs
    
    Succs = WritePrivateProfileString(Section, Cl, Valeur, Fichier)

End Sub

'
' Lecture d'une section complte d'un fichier ASCII(.INI)
'
Function EntresFichierASCII(Fichier As String, Section As String) As String

Dim Succs
Dim Rsultat As String * 1000
    
    Succs = GetPrivateProfileString(Section, 0&, "", Rsultat, Len(Rsultat), Fichier)
    
    ' Affiche les rsultats, s'ils sont trouvs.
    If Succs Then
        EntresFichierASCII = Left(Rsultat, Succs)
    Else
        EntresFichierASCII = ""
    End If

End Function

'
'
'
Function FormatChemin(Fichier As String) As String

Dim i As Integer

    For i = 1 To Len(Fichier)
        ' Rafraichit le 
        If Asc(Mid$(Fichier, i, 1)) = 144 Then
            Mid$(Fichier, i, 1) = ""
        End If
    Next i

    ' Retour
    FormatChemin = Fichier

End Function

'
' Lecture d'une chaine dans la base de registres
'
Function LectureChaineRegistre(Zone As Long, Section As String, Cl As String) As String

Dim Rsultat As String
Dim hSousClef As Long
Dim dwType As Long
Dim v As String
Dim SZ As Long
Dim Retour As Long

    ' Init
    Rsultat = ""

    ' Ouverture de la base de registre
    Retour = RegOpenKeyEx(Zone, Section, 0, KEY_ALL_ACCESS, hSousClef)

    ' Test ouverture de la base
    If Retour <> ERROR_SUCCESS Then
        ' Incident lors de l'ouverture
        GoTo Sortie
    Else
        ' Dfinition des
        SZ = 256: v = String$(SZ, 0)
        
        ' Lecture dans la base
        Retour = RegQueryValueEx(hSousClef, Cl, 0, dwType, ByVal v, SZ)
    
        If Retour = ERROR_SUCCESS And dwType = REG_SZ Then
            Rsultat = Left$(v, SZ)
        Else
            Rsultat = " "
        End If
        
        ' Fermeture de la base
        If Zone = 0 Then
            Retour = RegCloseKey(hSousClef)
        End If
    End If

Sortie:
    ' Rsultat
    LectureChaineRegistre = Rsultat

End Function

'
' Lecture d'informations  partir d'un fichier ASCII(.INI)
'
Function LectureFichierASCII(Fichier As String, Section As String, Cl As String) As String

Dim Succs
Dim Rsultat As String * 1000

    Succs = GetPrivateProfileString(Section, Cl, "", Rsultat, Len(Rsultat), Fichier)

    ' Affiche les rsultats, s'ils sont trouvs.
    If Succs Then
        LectureFichierASCII = Left(Rsultat, Succs)
    Else
        LectureFichierASCII = ""
    End If

End Function

'
' Rtablit les codes @ par CR et LF
'
Function RtablitZoneTexte(Info As String) As String

Dim i As Integer
    
    ' Remplacement des codes @ par CR + LF
    For i = 1 To Len(Info)
        If Mid$(Info, i, 1) = Chr$(124) And Mid$(Info, i + 1, 1) = Chr$(124) Then
            Mid$(Info, i, 1) = Chr$(13)
            Mid$(Info, i + 1, 1) = Chr$(10)
            i = i + 1
        End If
    Next i

    RtablitZoneTexte = Info

End Function

'
' Extraction de toutes les sections d'un fichier ASCII(.INI)
'
Function SectionsFichierASCII(Fichier As String) As String

Dim i, j As Integer
Dim Ligne As String
Dim Rsultat As String
Dim Canal As Integer

On Error GoTo Erreur

    Rsultat = ""
    Canal = FreeFile
    
    Open Fichier For Input As #Canal
        Do While Not EOF(Canal)
            Input #Canal, Ligne
            If InStr(1, Ligne, "[") > 0 Then
                Rsultat = Rsultat + Mid$(Ligne, 2, Len(Ligne) - 2) + Chr$(0)
            End If
        Loop
    Close #1

    SectionsFichierASCII = Rsultat
    Exit Function

Erreur:
    If Err = 53 Then
'        MsgBox "Fichier inexistant", 48, "Attention"
    End If
    
    SectionsFichierASCII = ""
    Exit Function

End Function

'
' Remplacement des codes CR et LF par @
' pour un enregistrement par EcritureFichierASCII
'
Function TransformeZoneTexte(Info As String) As String

Dim i As Integer
Dim Chaine As String

    Chaine = Trim$(Info)
    
    ' Remplacement des codes CR et LF par @
    For i = 1 To Len(Chaine)
        If Mid$(Chaine, i, 1) = Chr$(10) Or Mid$(Chaine, i, 1) = Chr$(13) Then
            Mid$(Chaine, i, 1) = Chr$(124)
        End If
    Next i

    ' Supprime le code '|'  la fin de la chaine
    While Mid$(Chaine, Len(Chaine), 1) = Chr$(124)
        Chaine = Mid$(Chaine, 1, Len(Chaine) - 1)
    Wend
    
    TransformeZoneTexte = Chaine

End Function

